#ifndef __FORMALISM_
#define __FORMALISM_

/*@
  predicate unchangedTab{L,M}(int *tab, int *tab2, integer i, integer n) = \forall integer j; i <= j < n ==> \at(tab[j],L) == \at(tab2[j],M);

  predicate swapInArrayAux{L,M}(int *t, int *s, integer i, integer n, integer j, integer k) = i<=j<=k<n ==>
  (unchangedTab{L,M}(t,s,i,j) && unchangedTab{L,M}(t,s,j+1,k) && unchangedTab{L,M}(t,s,k+1,n) && \at(t[j],L) == \at(s[k],M) && \at(t[k],L) == \at(s[j],M));

  predicate goodRangeForSwap(integer i, integer n, integer j, integer k) = i<=j<n && i<=k<n;

  predicate wrongRangedSwap{L,M}(int *t, int *s, integer i, integer n, integer j, integer k) =
  (j<i || k<i || j>=n || k>=n) ==> unchangedTab{L,M}(t,s,i,n);

  predicate swapInArray{L,M}(int *t, int *s, integer i, integer n, integer j, integer k) = swapInArrayAux{L,M}(t,s,i,n,j,k) && swapInArrayAux{L,M}(t,s,i,n,k,j)
    && wrongRangedSwap{L,M}(t,s,i,n,j,k);

  predicate minimum(int *t, integer i, integer n, integer min) = i<=min<n && \forall integer k; i<=k<n ==> t[min]<=t[k];

  predicate firstMinimum(int *t, integer i, integer n, integer min) = minimum(t,i,n,min) && \forall integer k; i <= k < min ==> t[min] < t[k];

  axiomatic CountTab{
	logic integer countTab{L}(int *t, integer i, integer n, int v) reads t[i .. n-1];

	axiom CountEmptyTab: \forall int *t, v, integer i,n; n<=i ==> countTab(t,i,n,v) == 0;

	axiom MatchElem: \forall int *t, v, integer i,n; i<n ==> t[n-1] == v ==> countTab(t,i,n,v) == countTab(t,i,n-1,v)+1;

	axiom MissElem: \forall int *t, v, integer i,n; i<n ==> t[n-1] != v ==> countTab(t,i,n,v) == countTab(t,i,n-1,v);
}

  predicate sorted(int *t, integer i, integer n) = \forall integer k,l; i<=k<l<n ==> t[k] <= t[l];

  axiomatic Permutation{
	predicate permutation{L,M}(int *t, int *s, integer i, integer n) reads \at(t[i .. n-1],L),\at(s[i .. n-1],M);

	axiom IdentityIsPermutation{L,M}: \forall int *t, *s, integer i, n; unchangedTab{L,M}(t,s,i,n) ==> permutation{L,M}(t,s,i,n);

	axiom SwapPermutation{L,M,K}: \forall int *t, *s, *u, integer i, n, a, b;  i<=a<n ==> i<=b<n ==> permutation{L,M}(t,s,i,n) ==> swapInArray{M,K}(s,u,i,n,a,b)
	 	 ==> permutation{L,K}(t,u,i,n);
}



 */


#endif
